#include "stdafx.h"
#include "NeMessenger.h"
#include "NeMessengerDlg.h"
#include "AESCrypto.h"
#include "LoginDlg.h"
#include "MemoView_explorer.h"
#include "CWebBrowser2.h"
#include "WorkGroupController.h"
#include "ChatDialogManager.h"
#include "SendNoteMananger.h"
#include "ReceivedNoteManager.h"
#include "SMSDialogManager.h"
#include "ChangeNoticeController.h"
#include "ChangeNoticePushController.h"
#include "ChangeNoticeDialogManager.h"
#include "CheckUPNoticeController.h"
#include "svn_Info.h"
//#include "TinyWebServer.h"
#include "FTImageMap.h"
#include "..\..\DuiLib\UIlib.h"
#include "main_frame.hpp"
#include "ServerAddrConfig.h"

using namespace DuiLib;

#define ID_TIMER_MANAGER_WND				(0xD010)

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

HANDLE hMutexOneInstance = NULL;

BEGIN_MESSAGE_MAP(CNeMessengerApp, CWinAppEx)
	//ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
	ON_COMMAND(ID__EXIT, &CNeMessengerApp::OnExit)
END_MESSAGE_MAP()

CNeMessengerApp::CNeMessengerApp()
: m_pChatDialogManager(new ChatDialogManager())
, m_pSendNoteManager(new SendNoteMananger(3))
, m_pReceivedNoteManager(new ReceivedNoteManager())
, m_pSMSDialogManager(new SMSDialogManager())
, m_pMessageBoxManager(new CMessageBoxManager())
, m_bAvailableIPT(FALSE)
, m_pChangeNoticeController(new ChangeNoticeController())
, m_pChangeNoticePushController(new ChangeNoticePushController())
, m_pChangeNoticeDialogManager(new ChangeNoticeDialogManager())
, m_pCheckUpNoticeController(new CCheckUPNoticeController())
, m_pTimerManager(new CTimerManager())
//, m_pTinyWebServer(new CTinyWebServer())
,m_bExitThenRun(false)
{
	srand( (unsigned)time( NULL ) );
}


CNeMessengerApp::~CNeMessengerApp()
{
	if (NULL != m_pChatDialogManager) delete m_pChatDialogManager;
	if (NULL != m_pSendNoteManager)	delete m_pSendNoteManager;
	if (NULL != m_pReceivedNoteManager) delete m_pReceivedNoteManager;
	if (NULL != m_pSMSDialogManager) delete m_pSMSDialogManager;
	if (NULL != m_pMessageBoxManager) delete m_pMessageBoxManager;
	if (NULL != m_pChangeNoticeController) delete m_pChangeNoticeController;
	if (NULL != m_pChangeNoticePushController) delete m_pChangeNoticePushController;
	if (NULL != m_pChangeNoticeDialogManager) delete m_pChangeNoticeDialogManager;
	if (NULL != m_pCheckUpNoticeController) delete m_pCheckUpNoticeController;
	if (NULL != m_pTimerManager) delete m_pTimerManager;
	//if (NULL != m_pTinyWebServer) delete m_pTinyWebServer;
}

CNeMessengerApp theApp;


BOOL CNeMessengerApp::InitInstance()  
{	
    //C6262: Function uses '28424' bytes of stack: exceeds /analyze:stacksize'16384'. Consider moving some data to heap

    CString strVersion;
	strVersion = Get_SVN_Rev();

	NTALK_LOG->Initialize();
	NTALK_LOG->Debug(L"[APP] INIT. REVISION = %s", strVersion);

    TCHAR szModuleName[MAX_PATH]= {0};
    TCHAR szDrive[_MAX_DRIVE] = {0};
    TCHAR szDir[_MAX_DIR] = {0};
    TCHAR szFName[_MAX_FNAME] = {0};
    TCHAR szExt[_MAX_EXT] = {0};

	CString strCurDir;

    INITCOMMONCONTROLSEX InitCtrls = {0};


	//Ʈ ʱȭ
	// Ʈ ʱȭ
	//314 :  bFont   ó μ ߰ Ұ...


	InitCtrls.dwSize = sizeof(InitCtrls);
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);
	CWinAppEx::InitInstance();
	AfxEnableControlContainer();
#ifdef NDEBUG
    BOOL bNtalk = FALSE;
    UNREFERENCED_PARAMETER(bNtalk);
	////////////// ߺ /////////////////////////////////
	hMutexOneInstance = ::CreateMutex(NULL, TRUE, MAIN_CAPTION_NAME);
	if(GetLastError() == ERROR_ALREADY_EXISTS)
	{
		//̹  
		bNtalk = TRUE;
	}

	if(bNtalk == TRUE)
	{
		HWND hWnd = ::FindWindow(NULL, MAIN_CAPTION_NAME);
		if(hWnd)
		{
			if(IsIconic(hWnd))
				ShowWindow(hWnd, SW_RESTORE);

			ShowWindow(hWnd, SW_SHOW);
			SetForegroundWindow(hWnd);
		}
		return FALSE;
	}
#else	
	//AfxMessageBox(_T("ߺڵ Ż"));
#endif

	::CoInitialize(NULL);
	if( !AfxOleInit() )
	{
		return FALSE;
	}

	AfxInitRichEdit(); //ġƮ 

	GdiplusStartupInput gdiplusStartupInput;
	GdiplusStartup(&m_gdiplusToken, &gdiplusStartupInput, NULL);

	SetRegistryKey(_T("Ntalkbiz"));

	// (θ н )
	GetModuleFileName(NULL, szModuleName, DIM(szModuleName));
	_tsplitpath_s(szModuleName, szDrive, szDir, szFName, szExt);	
	strCurDir.Format(_T("%s%s"), szDrive, szDir);
	SetCurrentDirectory(strCurDir); //  ٸ ҽ  ϰ Ƿ...Ŀ 

	m_pClientConfig = new CClientConfig;

	if (NULL != m_pClientConfig) 
	{
		m_pClientConfig->LoadClientConfig();
		m_pClientConfig->LoadTinyWebServerConfig();
		m_pClientConfig->LoadAutoText();
	}

	//if (NULL != m_pTinyWebServer && NULL !=m_pClientConfig && 0 != m_pClientConfig->GetTinyWebServerAutoStart())
	//{
	//	m_pTinyWebServer->StartWebServer();
	//}

	SetGlobalUserInfo();

	//   (ҽ)
	SetLangPack(g_stNtalkInfo.nLang, TRUE);	

	CreateLauguageDefaultFont();

	// API Init....
	GT_API_ENVIRONMENT_DATA sEnv;
	memset(&sEnv, 0, sizeof(sEnv));

	sEnv.hInstance = AfxGetInstanceHandle();


	if( g_stNtalkInfo.strCorp == _T("hanatour") )
	{
        _tcscpy_s(sEnv.sLoginServerAddress.strAddress, 256, CServerAddrConfig::Instance().GetHanatourServerIp());// HANATOUR_SERVER_IP);
	}
	else
	{
        _tcscpy_s(sEnv.sLoginServerAddress.strAddress, 256, CServerAddrConfig::Instance().GetNhnServerIp());// NHN_SERVER_IP);
	}

    UINT nRandPort = rand() % CServerAddrConfig::Instance().GetPortCount();// PORT_COUNT_FROM_10500;
    sEnv.sLoginServerAddress.nPort = CServerAddrConfig::Instance().GetServerPort() + nRandPort; //SERVER_PORT

	CString strDefaultGroupName;
	strDefaultGroupName.LoadString(IDS_DEFAULT_GROUPNAME);
	sEnv.strDefaultBuddyGroupName = strDefaultGroupName; // ׷  ⺻׷

	NeMessengerAPISetting::SetEnvironment(sEnv);

	if(!NeMessengerAPI::InitNeMessengerAPI(GT_API_VERSION))
	{
		AfxMessageBox(_T("error InitNeMessengerAPI"));
		NTALK_LOG->Error(L"[APP] INIT. Failed. (InitNeMessengerAPI)");
		return FALSE;
	}

	if(!NeMessengerAPI::CreateMessengerActor(0, &g_pMessengerActor))
	{
		AfxMessageBox(_T("error CreateMessengerActor"));
		NTALK_LOG->Error(L"[APP] INIT. Failed. (CreateMessengerActor)");
		return FALSE;
	}

	WSTRING strWASServer = _T("");
	if( g_stNtalkInfo.strCorp == _T("hanatour") )
	{
        strWASServer = CServerAddrConfig::Instance().GetHanatourWasServer();// HANATOUR_WAS_SERVER;
	}
	else
	{
        strWASServer = CServerAddrConfig::Instance().GetNhnWasServer();// NHN_WAS_SERVER;
	}

	g_pMessengerActor->GetWASActor()->SetWASServerAddress(strWASServer);
	// XTP Skin ʱȭ
	//LoadBaseXTSkin();

	// Ntalk ʱȭ
	InitNTalk();

	CPaintManagerUI::SetInstance(sEnv.hInstance);
	CPaintManagerUI::SetResourcePath(CPaintManagerUI::GetInstancePath() + _T("skin\\nTalkRes"));

	CFTImageMapInt::Instance()->Init();

	CNeMessengerDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: ⿡ [Ȯ] ŬϿ ȭ ڰ   ó
		//  ڵ带 ġմϴ.
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: ⿡ [] ŬϿ ȭ ڰ   ó
		//  ڵ带 ġմϴ.
	}

	NTALK_LOG->Debug(L"[APP] EXIT.");

	CFTImageMapInt::Instance()->Release();
	////////////////////////////////

	// ȭ ڰ Ƿ  α׷ ޽   ʰ   α׷   ֵ FALSE
	// ȯմϴ.
	return FALSE;
}

int CNeMessengerApp::ExitInstance()
{
	////////////////////////////////
	// API Clean....

	try
	{
		CUserImageActor::Instance()->GetUserImageHandler().WaitThreadExit();

		if (g_pMessengerActor)
			NeMessengerAPI::CleanNeMessengerAPI();

		if(m_pClientConfig)
		{
			delete m_pClientConfig;
			m_pClientConfig = NULL;
		}

		CleanNTalk();
    }
	catch (...)
	{
		GdiplusShutdown(m_gdiplusToken);
		::CoUninitialize();
		return CWinAppEx::ExitInstance();
	}

	if(hMutexOneInstance)
	{
		CloseHandle(hMutexOneInstance);
		hMutexOneInstance = NULL;
	}

	if(m_bExitThenRun)
	{
        TCHAR szPath[MAX_PATH] = {0};
		GetModuleFileName(NULL, szPath, MAX_PATH);
        STARTUPINFO startupInfo = {0};
        PROCESS_INFORMATION procInfo = {0};
		memset(&startupInfo,0x00,sizeof(STARTUPINFO));
		startupInfo.cb = sizeof(STARTUPINFO);
		if(::CreateProcess(szPath,NULL,NULL,NULL,FALSE,NORMAL_PRIORITY_CLASS,NULL,NULL,&startupInfo,&procInfo))
        {
            CloseHandle(procInfo.hProcess);
            CloseHandle(procInfo.hThread);
        }
	}

	GdiplusShutdown(m_gdiplusToken);
	::CoUninitialize();
	return CWinAppEx::ExitInstance();
}

int CNeMessengerApp::SetWindowRegion(CWnd* pWnd, UINT nResourceID/* = IDR_MAINDLG_RGN*/)
{
	HRGN hMainRgn = NULL;
	HRSRC hResourceInfo = NULL;
	HGLOBAL hGlobal = NULL;

	hResourceInfo = FindResource(AfxGetInstanceHandle(), MAKEINTRESOURCE(nResourceID), _T("RGN"));
	hGlobal = LoadResource(AfxGetInstanceHandle(), hResourceInfo);
	if(hGlobal)
	{
		BYTE *pRgnData = (BYTE FAR*)LockResource(hGlobal);
		if(pRgnData != NULL)
		{
			hMainRgn = ExtCreateRegion(NULL, sizeof(RGNDATAHEADER) + (sizeof(RECT) * ((RGNDATA*)pRgnData)->rdh.nCount),(RGNDATA*)pRgnData);
			::UnlockResource(hGlobal);
		}
		::FreeResource(hGlobal);
	}

	pWnd->SetWindowRgn(hMainRgn, TRUE);



	return 0;
}

// ڵα, ȣȭ ̵, н, Ƽ׳ͽ ,  
void CNeMessengerApp::SetGlobalUserInfo()
{
	int userLanguage = 0;
	int userAutoLogin = False;

	if (NULL != m_pClientConfig)
	{
		userLanguage = m_pClientConfig->GetLanguage();
		userAutoLogin =  m_pClientConfig->GetAutoLogin();
	}

	// ٱ  
	g_stNtalkInfo.nLang = userLanguage;

	// ڵα 
	g_stNtalkInfo.bAutoLogin = userAutoLogin == 1 ? TRUE : FALSE;

	GetUserIdPasswd(m_pClientConfig, g_stNtalkInfo);

	GetTenantInfo(m_pClientConfig, g_stNtalkInfo);
}

void CNeMessengerApp::CreateLauguageDefaultFont()
{
	CString defaultFontFaceName = GetDefaultFontFaceName();

	g_ftGulim6PT.Attach(CreateSmartFont(GULIM_KOREAN_FONT_T,6));
	g_ftGulim7PT.Attach(CreateSmartFont(GULIM_KOREAN_FONT_T,7));
	g_ftGulim8PT.Attach(CreateSmartFont(GULIM_KOREAN_FONT_T,8));
	g_ftGulim9PT.Attach(CreateSmartFont(GULIM_KOREAN_FONT_T,9));
	g_ftGulim10PT.Attach(CreateSmartFont(GULIM_KOREAN_FONT_T,10));

	g_ftDefault6PT.Attach(CreateSmartFont(defaultFontFaceName, 6));
	g_ftDefault7PT.Attach(CreateSmartFont(defaultFontFaceName, 7));
	g_ftDefault8PT.Attach(CreateSmartFont(defaultFontFaceName, 8));
	g_ftDefault9PT.Attach(CreateSmartFont(defaultFontFaceName, 9));
	g_ftDefault10PT.Attach(CreateSmartFont(defaultFontFaceName, 10));
	g_ftDefault11PT.Attach(CreateSmartFont(defaultFontFaceName, 11));
	g_ftDefault12PT.Attach(CreateSmartFont(defaultFontFaceName, 12));
	g_ftDefault13PT.Attach(CreateSmartFont(defaultFontFaceName, 13));
	g_ftDefault14PT.Attach(CreateSmartFont(defaultFontFaceName, 14));

	g_ftDefault9PTB.Attach(CreateSmartFont(defaultFontFaceName, 9, FW_BOLD));
	g_ftDefault10PTB.Attach(CreateSmartFont(defaultFontFaceName, 10, FW_BOLD));
	g_ftDefault11PTB.Attach(CreateSmartFont(defaultFontFaceName, 11, FW_BOLD));

	// px  Ʈ 2px  ũش.
	g_ftDefault8PX.Attach(CreateSmartPixelFont(defaultFontFaceName,10));
	g_ftDefault9PX.Attach(CreateSmartPixelFont(defaultFontFaceName,11));
	g_ftDefault10PX.Attach(CreateSmartPixelFont(defaultFontFaceName,12));
	g_ftDefault11PX.Attach(CreateSmartPixelFont(defaultFontFaceName,13));
	g_ftDefault12PX.Attach(CreateSmartPixelFont(defaultFontFaceName,14));
	g_ftDefault13PX.Attach(CreateSmartPixelFont(defaultFontFaceName,15));
	g_ftDefault14PX.Attach(CreateSmartPixelFont(defaultFontFaceName,16));

	g_ftDefault12PXB.Attach(CreateSmartPixelFont(defaultFontFaceName,14 ,FW_BOLD));
	g_ftDefault13PXB.Attach(CreateSmartPixelFont(defaultFontFaceName,15 ,FW_BOLD));
	g_ftDefault14PXB.Attach(CreateSmartPixelFont(defaultFontFaceName,16 ,FW_BOLD));
	g_ftDefault15PXB.Attach(CreateSmartPixelFont(defaultFontFaceName,18 ,FW_BOLD));


	g_ftDotum10PX.Attach(CreateSmartPixelFont(DOTUM_KOREAN_FONT_NAME,11));
	g_ftDotum11PX.Attach(CreateSmartPixelFont(DOTUM_KOREAN_FONT_NAME,12));
	g_ftDotum12PX.Attach(CreateSmartPixelFont(DOTUM_KOREAN_FONT_NAME,13));
	g_ftDotum13PX.Attach(CreateSmartPixelFont(DOTUM_KOREAN_FONT_NAME,14));

	g_ftDotum10PXB.Attach(CreateSmartPixelFont(DOTUM_KOREAN_FONT_NAME,11 ,FW_BOLD));
	g_ftDotum11PXB.Attach(CreateSmartPixelFont(DOTUM_KOREAN_FONT_NAME,12 ,FW_BOLD));
	g_ftDotum12PXB.Attach(CreateSmartPixelFont(DOTUM_KOREAN_FONT_NAME,13 ,FW_BOLD));
	g_ftDotum13PXB.Attach(CreateSmartPixelFont(DOTUM_KOREAN_FONT_NAME,14 ,FW_BOLD));

	g_defaultFontFaceName = GetDefaultFontFaceNameW();
}

bool CNeMessengerApp::GetUserIdPasswd(CClientConfig *pConfig, NTALK_INFO &info)
{
	// ȣȭ id/pw ó
	if(NULL != pConfig && pConfig->GetSIP().GetLength() > 0)
	{
		// 0. ȣȭ
		////////////
		int nLen;
		char* pszSIP;
		USES_CONVERSION;
		pszSIP = W2A(pConfig->GetSIP());
		unsigned char* byteEnc = base64_decode((unsigned char*)pszSIP, &nLen);
		char* pszPlainSIP = new char[nLen];
		if(byteEnc && pszPlainSIP)
		{			
			DecryptSIP(GetHddSerial(), byteEnc, nLen, pszPlainSIP);

			CString strSIP(pszPlainSIP);
			int nPos = strSIP.Find(_T('/'));
			if(nPos)
			{
				CString strDecID = strSIP.Left(nPos);
				CString strDecPW = strSIP.Mid(nPos + 1);

				// 1. "/" и
				///////////////////					
				info.strId = strDecID;		
				info.strPassword = strDecPW;
			}
		}

		if (NULL != byteEnc)
		{
			free(byteEnc);
		}

		if(pszPlainSIP)
		{
			delete [] pszPlainSIP;
			pszPlainSIP = NULL;
		}
	}
	else
		return false;

	return true;
}

bool CNeMessengerApp::GetTenantInfo(CClientConfig *pConfig, NTALK_INFO &info)
{
	CString strDecMTS;

	// ȣȭ Ƽ׳ͽ 
	if(NULL == pConfig || pConfig->GetSMTS().IsEmpty())
		strDecMTS = _T("nhncorp/nts");
	else
	{
		strDecMTS = pConfig->GetSMTS();		
	}

	int nPos = strDecMTS.Find(_T("/"));
	if(nPos > 0)
	{
		CString strDecCorp = strDecMTS.Left(nPos);
		CString strDecDomain = strDecMTS.Mid(nPos + 1);
		// 1. "/"ͺи
		///////////////////		
		OutputDebugString(_T("\r\n##### "));

		info.strCorp = strDecCorp;
		OutputDebugString(g_stNtalkInfo.strCorp);

		info.strDomain = strDecDomain;
		OutputDebugString(g_stNtalkInfo.strDomain);

		OutputDebugString(_T(" #####\r\n"));
	}
	else
		return false;

	return true;
}

void CNeMessengerApp::ExitThenRun()
{
	m_bExitThenRun = true;
}

/*
ٱҽ 
*/
void CNeMessengerApp::SetLangPack(int nLang, BOOL bFirst)
{	
#ifndef _DEBUG
	const TCHAR szEng[] = _T("EngPack.dll");
	const TCHAR szJpn[] = _T("JpnPack.dll");
	const TCHAR szChnT[] = _T("ChnTPack.dll");
	const TCHAR szChnS[] = _T("ChnSPack.dll");
#else
	const TCHAR szEng[] = _T("EngPackD.dll");
	const TCHAR szJpn[] = _T("JpnPackD.dll");
	const TCHAR szChnT[] = _T("ChnTPackD.dll");
	const TCHAR szChnS[] = _T("ChnSPackD.dll");
#endif

    TCHAR szModuleName[MAX_PATH] = {0};
    TCHAR szDrive[_MAX_DRIVE] = {0};
    TCHAR szDir[_MAX_DIR]={0};
    TCHAR szFName[_MAX_FNAME]={0};
    TCHAR szExt[_MAX_EXT]={0};
	CString strCurDir;	
	CString strResFname;
	CString strResPath;

    if(bFirst){ // ó ö  ѱ ҽ
		m_hInstResKor = AfxGetResourceHandle();
    }
	if(nLang != NTALK_LANG_KOREAN) //Ÿ
	{	
		// (θ н )
		GetModuleFileName(NULL, szModuleName, DIM(szModuleName));
		_tsplitpath_s(szModuleName, szDrive, szDir, szFName, szExt);	
		strCurDir.Format(_T("%s%s"), szDrive, szDir);

		if(nLang == NTALK_LANG_ENGLISH) //eng
			strResFname = szEng;
		else if(nLang == NTALK_LANG_JAPANESE)
			strResFname = szJpn;
		else if(nLang == NTALK_LANG_CHINESE_TRADITIONAL)
			strResFname =szChnT;
		else if(nLang == NTALK_LANG_CHINESE_SIMPLIFIED)
			strResFname = szChnS;

		strResPath.Format(_T("%s%s"), strCurDir, strResFname);
		HINSTANCE hResDll = LoadLibrary(strResPath);
		ASSERT(hResDll != NULL);
		AfxSetResourceHandle(hResDll);
	}
	else
	{
		if(bFirst == FALSE)
			AfxSetResourceHandle(m_hInstResKor);
	}

	// Ǿ ִ ̾α ҽ 
	if(bFirst == FALSE)
	{
		((CNeMessengerDlg*)m_pMainWnd)->__ResourceLoad();
		((CNeMessengerDlg*)m_pMainWnd)->GetMainFrame()->__ResourceLoad();
		((CNeMessengerDlg*)m_pMainWnd)->GetLoginDlg().__ResourceLoad();
		if(((CNeMessengerDlg*)m_pMainWnd)->GetConfigDlg().GetSafeHwnd())
			((CNeMessengerDlg*)m_pMainWnd)->GetConfigDlg().__ResourceLoad();
		((CNeMessengerDlg*)m_pMainWnd)->GetWorkGroupController()->SetViewLanguagePack();		
		m_pReceivedNoteManager->SetViewLanguagePack();
		m_pSendNoteManager->SetViewLanguagePack();
		m_pSMSDialogManager->SetViewLanguagePack();
		m_pChatDialogManager->SetViewLanguagePack();
	}

}

/*!
* @brief     XTP Skin  ϱ  ʱȭ. LoadSkin()   ȣ  ߽Ų   Ƿ
LoadSkin() ̰   ȣϰ, ٸ  CreateSchema() Ű   SetWindowTheme() Ѵ.
* @return    BOOL
* @param     void
* @author    Jinwoo.Lee(jinwoo.lee@nhn.com)
* @date      2012-04-03
* @warning   LoadSkin() ȣ  ü Ų   Ƿ, ⼭ ȣؾ .
*/
//BOOL CNeMessengerApp::LoadBaseXTSkin()
//{
//	TCHAR szStylesPath[_MAX_PATH];
//
//	VERIFY(::GetModuleFileName(AfxGetApp()->m_hInstance, szStylesPath, _MAX_PATH));		
//
//	CString strStylesPath = szStylesPath;
//	int nIndex  = strStylesPath.ReverseFind(_T('\\'));
//	if (nIndex > 0) {
//		strStylesPath = strStylesPath.Left(nIndex);
//	}
//	else {
//		strStylesPath.Empty();
//	}
//	strStylesPath += _T("\\IMAGES\\Style\\");
//
//	/*
//	* : XTPSkin ϴ ȭ 
//	*  ȭڸ SetApplyOptions() ϰ ִ  NeMessenger.cpp  ʱ⿡ 1ȸ ϵ .
//	* ( ȭڸ SetApplyOptions() ȣ  ȭڰ ߸鼭  ִ ȭ client  ̴  )
//	* , Ŀ ٸ  SetApplyOptions() ȣ ʵ Ѵ.
//	*/
//	XTPSkinManager()->SetApplyOptions(xtpSkinApplyFrame);
//	XTPSkinManager()->SetAutoApplyNewWindows(FALSE);
//	BOOL bRet = XTPSkinManager()->LoadSkin(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"));	
//
//	return bRet;
//}

void CNeMessengerApp::OnExit()
{
	bool test = false;
}

CString CNeMessengerApp::GetAppDataDir()
{
	LPITEMIDLIST lpi;
	HRESULT hResult;
	TCHAR pszPath[MAX_PATH] = {'\0',};

	hResult = SHGetSpecialFolderLocation(NULL, CSIDL_LOCAL_APPDATA, &lpi);
	SHGetPathFromIDList(lpi, pszPath);

	CoTaskMemFree(lpi);

	_tcscat_s(pszPath, MAX_PATH, _T("\\Ntalkbiz"));
	if(_waccess(pszPath, 0) == -1)
		_wmkdir(pszPath);

	return pszPath;
}

CString CNeMessengerApp::GetProfileImagePath(LPCTSTR strUserID, BOOL bCheckFile /* = TRUE */, BOOL bGetDefault /* = TRUE */)
{
    BOOL bRet = FALSE;
    CString strPath = GET_APP()->GetAppDataDir() + _T("\\UserInfo\\");
    if (!PathFileExists(strPath))
    {
        API_VERIFY(CreateDirectory(strPath, NULL));
    }
    strPath += strUserID;

    if (bCheckFile)
    {
        if (PathFileExists(strPath))
        {
            BOOL bCheckFileOK = TRUE;
            {
                Image checkImage(strPath);
                bCheckFileOK = (Gdiplus::Ok == checkImage.GetLastStatus()
                    && checkImage.GetWidth() != 0
                    && checkImage.GetHeight() != 0);
            }
            if (!bCheckFileOK)
            {
                API_VERIFY(DeleteFile(strPath));
            }
        }
    }

    if (!PathFileExists(strPath) && bGetDefault)
    {
        strPath = GetAppDUIImgDir() + _T("\\main_profile_blank.png");
    }

    return strPath;
}

CString CNeMessengerApp::GetBuddyPresenceImageFilePath(GTUserStatusType status)
{
	CString strFileName;

	switch (status)
	{
	case ustOFFLINE:
		strFileName = _T("img_organization_state_offline.png");
		break;		
	case ustOFFLINE | ustMOBILE:
		strFileName = _T("img_organization_state_mobile.png");
		break;		
	case ustONLINE:
		strFileName = _T("img_organization_state_online.png");
		break;
	case ustONLINE | ustMOBILE:
		strFileName = _T("img_organization_state_online.png");
		break;
	case ustAWAY:
	case ustAUTOAWAY:
		strFileName = _T("img_organization_state_seat.png");
		break;
	case ustAWAY | ustMOBILE:
		strFileName = _T("img_organization_state_seat.png");
		break;
	case ustAUTOAWAY | ustMOBILE:
		strFileName = _T("img_organization_state_mobile.png");
		break;
	case ustBUSY:
		strFileName = _T("img_organization_state_different.png");
		break;
	case ustBUSY | ustMOBILE:
		strFileName = _T("img_organization_state_different.png");
		break;
	case ustOUTSIDE:
		strFileName = _T("img_organization_state_office.png");
		break;
	case ustOUTSIDE | ustMOBILE:
		strFileName = _T("img_organization_state_office.png");
		break;
	case ustEAT:
		strFileName = _T("img_organization_state_meal.png");
		break;
	case ustEAT | ustMOBILE:
		strFileName = _T("img_organization_state_meal.png");
		break;
	case ustMEETING:
		strFileName = _T("img_organization_state_seat.png");
		break;
	case ustMEETING | ustMOBILE:
		strFileName = _T("img_organization_state_seat.png");
		break;
	default:
		strFileName = _T("img_organization_state_offline.png");
		break;		
	}

	CString strImageFilePath;
	strImageFilePath.Format(_T("%s\\%s"), GetAppImgDir(), strFileName);

	return strImageFilePath;
}

CString CNeMessengerApp::GetMyPresenceImageFileName(GTUserStatusType status)
{
	CString strFileName;

	switch (status)
	{
	case ustOFFLINE:
		strFileName = _T("New_Info_AboutMe_Status_OffLine.png");
		break;
	case ustOFFLINE | ustMOBILE:
		strFileName = _T("New_Info_AboutMe_Status_OffLine_MobileOn.png");
		break;
	case ustONLINE:
		strFileName = _T("New_Info_AboutMe_Status_OnLine.png");
		break;
	case ustONLINE | ustMOBILE:
		strFileName = _T("New_Info_AboutMe_Status_OnLine_MobileOn.png");
		break;
	case ustAWAY:
	case ustAUTOAWAY:
		strFileName = _T("New_Info_AboutMe_Status_Absence.png");
		break;
	case ustAWAY | ustMOBILE:
	case ustAUTOAWAY | ustMOBILE:
		strFileName = _T("New_Info_AboutMe_Status_Absence_MobileOn.png");
		break;
	case ustBUSY:
		strFileName = _T("New_Info_AboutMe_Status_Business.png");
		break;
	case ustBUSY | ustMOBILE:
		strFileName = _T("New_Info_AboutMe_Status_Business_MobileOn.png");
		break;
	case ustOUTSIDE:
		strFileName = _T("New_Info_AboutMe_Status_Outside.png");
		break;
	case ustOUTSIDE | ustMOBILE:
		strFileName = _T("New_Info_AboutMe_Status_Outside_MobileOn.png");
		break;
	case ustEAT:
		strFileName = _T("New_Info_AboutMe_Status_Eat.png");
		break;
	case ustEAT | ustMOBILE:
		strFileName = _T("New_Info_AboutMe_Status_Eat_MobileOn.png");
		break;
	case ustMEETING:
		strFileName = _T("New_Info_AboutMe_Status_Meeting.png");
		break;
	case ustMEETING | ustMOBILE:
		strFileName = _T("New_Info_AboutMe_Status_Meeting_MobileOn.png");
		break;
	default:
		strFileName = _T("New_Info_AboutMe_Status_OnLine.png");
		break;
	}

	return strFileName;
}

CString CNeMessengerApp::GetOrgIPTPresenceImageFilePath(NTIPTStatusType iptStatus)
{
	CString strFileName;

	switch (iptStatus)
	{
	case iptstIDLE:
		strFileName = _T("IPT_Presence_Idle.png");
		break;
	case iptstACTIVE:
		strFileName = _T("IPT_Presence_Active.png");
		break;
	case itpstALERTING:
		strFileName = _T("IPT_Presence_Alerting.png");
		break;
	case itpstHELD:
		strFileName = _T("IPT_Presence_Held.png");
		break;
	case iptstUNKNOWN:
		strFileName = _T("IPT_Presence_Unknown.png");
		break;
	case iptstNA:
		strFileName = _T("IPT_Presence_NA.png");
		break;
	case iptstDND:
		strFileName = _T("IPT_Presence_DND.png");
		break;
	case iptstFWD:
		strFileName = _T("IPT_Presence_FWD.png");
		break;	
	default:
		strFileName = _T("IPT_Presence_NA.png");
		break;
	}

	CString strImageFilePath;
	strImageFilePath.Format(_T("%s\\%s"), GetAppImgDir(), strFileName);

	return strImageFilePath;
}

CString CNeMessengerApp::GetBuddyIPTPresenceImageFilePath(NTIPTStatusType iptStatus)
{
	CString strFilePath;

	switch (iptStatus)
	{
	case iptstIDLE:
		strFilePath = GetAppDUIImgDir() + _T("\\img_main_title_ipticon_call.png");
		break;
	case iptstACTIVE:
		strFilePath = GetAppDUIImgDir() + _T("\\img_main_title_ipticon_busy.png");
		break;
	case itpstALERTING:
		strFilePath = GetAppDUIImgDir() + _T("\\img_main_title_ipticon_busy.png");
		break;
	case itpstHELD:
		strFilePath = GetAppDUIImgDir() + _T("\\img_main_title_ipticon_waitcall.png");
		break;
	case iptstUNKNOWN:
		strFilePath = _T("");
		break;
	case iptstNA:
		strFilePath = _T("");
		break;
	case iptstDND:
		strFilePath = GetAppDUIImgDir() + _T("\\img_main_title_ipticon_nocall.png");
		break;
	case iptstFWD:
		strFilePath = GetAppDUIImgDir() + _T("\\img_main_title_ipticon_changcall.png");
		break;	
	default:
		strFilePath = _T("");
		break;
	}

	return strFilePath;
}
CString CNeMessengerApp::GetMyIPTPresenceImageFilePath( NTIPTStatusType iptStatus )
{
	CString strFilePath;

	switch (iptStatus)
	{
	case iptstIDLE:
		strFilePath = GetAppDUIImgDir() + _T("\\img_main_title_ipticon_call.png");
		break;
	case iptstACTIVE:
		strFilePath = GetAppDUIImgDir() + _T("\\img_main_title_ipticon_busy.png");
		break;
	case itpstALERTING:
		strFilePath = GetAppDUIImgDir() + _T("\\img_main_title_ipticon_busy.png");
		break;
	case itpstHELD:
		strFilePath = GetAppDUIImgDir() + _T("\\img_main_title_ipticon_waitcall.png");
		break;
	case iptstUNKNOWN:
		strFilePath = _T("");
		break;
	case iptstNA:
		strFilePath = _T("");
		break;
	case iptstDND:
		strFilePath = GetAppDUIImgDir() + _T("\\img_main_title_ipticon_nocall.png");
		break;
	case iptstFWD:
		strFilePath = GetAppDUIImgDir() + _T("\\img_main_title_ipticon_changcall.png");
		break;	
	default:
		strFilePath = _T("");
		break;
	}

	return strFilePath;
}

CString CNeMessengerApp::GetWorkStatusImageFilePath()
{
	CString strFileName;
	strFileName = _T("img_organization_state_offline_vacation.png");

	CString strImageFilePath;
	strImageFilePath.Format(_T("%s\\%s"), GetAppImgDir(), strFileName);

	return strImageFilePath;

}

UINT CNeMessengerApp::GetMyPresenceTrayIconResourceID(GTUserStatusType status)
{
	UINT uResourceID = IDR_MAINFRAME;

	switch (status)
	{
	case ustOFFLINE:
	case ustOFFLINE | ustMOBILE:
		uResourceID = IDI_IC_TRAY_OFFLINE;
		break;
	case ustONLINE:
	case ustONLINE | ustMOBILE:
		uResourceID = IDI_IC_TRAY_ONLINE;
		break;
	case ustAWAY:
	case ustAUTOAWAY:
	case ustAWAY | ustMOBILE:
	case ustAUTOAWAY | ustMOBILE:
		uResourceID = IDI_IC_TRAY_MEETING;
		break;
	case ustBUSY:
	case ustBUSY | ustMOBILE:
		uResourceID = IDI_IC_TRAY_BUSY;
		break;
	case ustOUTSIDE:
	case ustOUTSIDE | ustMOBILE:
		uResourceID = IDI_IC_TRAY_OUTSIDE;
		break;
	case ustEAT:
	case ustEAT | ustMOBILE:
		uResourceID = IDI_IC_TRAY_EAT;
		break;
	case ustMEETING:
	case ustMEETING | ustMOBILE:
		uResourceID = IDI_IC_TRAY_MEETING;
		break;
	default:
		uResourceID = IDI_IC_TRAY_OFFLINE;
		break;
	}

	return uResourceID;
}

BOOL CNeMessengerApp::IsAvailableIPT()
{
	return GET_CONFIG()->EnableFunction(_T("ME_04")) && m_bAvailableIPT; 
}

void CNeMessengerApp::EnableIPT()
{
	m_bAvailableIPT = TRUE;
}

void CNeMessengerApp::DisableIPT()
{
	m_bAvailableIPT = FALSE;
}

void CNeMessengerApp::CreateTimerManager(CWnd* pParent)
{
	CString strTmpClassName;
	strTmpClassName.Format(_T("Ntalk_TimerManager_%X%X%X"),
		GetTickCount(),
		GetCurrentProcessId(),
		GetCurrentThreadId());
	RegisterWindowClass(strTmpClassName);

	CRect rtWnd(0, 0, 0, 0);
	m_pTimerManager->CreateEx(0, strTmpClassName, _T("Ntalk_TimerManager"), WS_CHILD, rtWnd, pParent, ID_TIMER_MANAGER_WND);
	m_pTimerManager->ShowWindow(SW_HIDE);
}
